#include "functions-irc.h"
#include "classes-irc.h"
#include "functions-xs-macros.h"
#include "utils.h"

SF_GEN(irssi_irc_dcc_chat_find_id, "S", SIOBJ, dcc_chat_find_id(a[0].s))
SF_GEN(irssi_irc_dcc_find_request, "jS.S", SIOBJ, dcc_find_request(a[0].i, a[1].s, a[2].s))
SF_GEN(irssi_irc_dcc_find_request_latest, "j", SIOBJ, dcc_find_request_latest(a[0].i))
SF_GEN(irssi_irc_dcc_get_download_path, "S", XSTR, dcc_get_download_path(a[0].s))
SF_GEN(irssi_irc_dcc_register_type, "S", VOID, dcc_register_type(a[0].s))
SF_GEN(irssi_irc_dcc_str2type, "S", INT, dcc_str2type(a[0].s))
SF_GEN(irssi_irc_dcc_type2str, "j", STR, module_find_id_str("DCC", a[0].i))
SF_GEN(irssi_irc_dcc_unregister_type, "S", VOID, dcc_unregister_type(a[0].s))
SF_GEN(irssi_irc_dccs, "", SIOBJARR, dcc_conns)
SF_GEN(irssi_irc_notifies, "", TOBJARR(Irssi::Irc::Notifylist), notifies)
SF_GEN(irssi_irc_notifylist_add, "SSb/j", TOBJ(Irssi::Irc::Notifylist), notifylist_add(a[0].s, a[1].s, a[2].b))
SF_GEN(irssi_irc_notifylist_find, "SS", TOBJ(Irssi::Irc::Notifylist), notifylist_find(a[0].s, a[1].s))
SF_GEN(irssi_irc_notifylist_ison, "SS", IOBJ, notifylist_ison(a[0].s, a[1].s))
SF_GEN(irssi_irc_notifylist_remove, "S", VOID, notifylist_remove(a[0].s))
SF_GEN(irssi_irc_get_mask, "SSj", STR, irc_get_mask(a[0].s, a[1].s, a[2].i))



SV_GEN(irssi_irc_notifylist, ircnets_match, NOTIFYLIST_REC, "S", BOOL, notifylist_ircnets_match(N, a[0].s))


SV_GEN(irssi_irc_server, ctcp_send_reply, IRC_SERVER_REC, "S", VOID, ctcp_send_reply(N, a[0].s))
SV_GEN(irssi_irc_server, get_channels, IRC_SERVER_REC, "", XSTR, irc_server_get_channels(N))
SV_GEN(irssi_irc_server, isupport, IRC_SERVER_REC, "S", STR, g_hash_table_lookup(N->isupport, a[0].s))
SV_GEN(irssi_irc_server, netsplit_find, IRC_SERVER_REC, "S.S", TOBJ(Irssi::Irc::Netsplit), netsplit_find(N, a[0].s, a[1].s))
SV_GEN(irssi_irc_server, netsplit_find_channel, IRC_SERVER_REC, "S.SS", TOBJ(Irssi::Irc::Netsplitchannel), netsplit_find_channel(N, a[0].s, a[1].s, a[2].s))
SV_GEN(irssi_irc_server, notifylist_ison_server, IRC_SERVER_REC, "S", BOOL, notifylist_ison_server(N, a[0].s))

SF_GEN(irssi_irc_server_query_create, "SSb", IOBJ, irc_query_create(a[0].s, a[1].s, a[2].b)) /* XXX */

SV_GEN(irssi_irc_server, redirect_get_signal, IRC_SERVER_REC, ".SS.S", STR, server_redirect_get_signal(N, a[0].s, a[1].s, a[2].s))

SV_GEN(irssi_irc_server, send_raw, IRC_SERVER_REC, "S", VOID, irc_send_cmd(N, a[0].s))
SV_GEN(irssi_irc_server, send_raw_first, IRC_SERVER_REC, "S", VOID, irc_send_cmd_first(N, a[0].s))
SV_GEN(irssi_irc_server, send_raw_now, IRC_SERVER_REC, "S", VOID, irc_send_cmd_now(N, a[0].s))
SV_GEN(irssi_irc_server, send_raw_split, IRC_SERVER_REC, "Sjj", VOID, irc_send_cmd_split(N, a[0].s, a[1].i, a[2].i))


SV_GEN(irssi_irc_channel, ban_get_mask, IRC_CHANNEL_REC, "Sj", XSTR, ban_get_mask(N, a[0].s, a[1].i))
SV_GEN(irssi_irc_channel, banlist_add, IRC_CHANNEL_REC, "SSj", TOBJ(Irssi::Irc::Ban), banlist_add(N, a[0].s, a[1].s, a[2].i))
SV_GEN(irssi_irc_channel, banlist_remove, IRC_CHANNEL_REC, "SS", VOID, banlist_remove(N, a[0].s, a[1].s))
SV_GEN(irssi_irc_channel, bans, IRC_CHANNEL_REC, "", TOBJARR(Irssi::Irc::Ban), N->banlist)
SV_GEN(irssi_irc_channel, nick_insert, IRC_CHANNEL_REC, "Sbbbb/.S", IOBJ, irc_nicklist_insert(N, a[0].s, a[1].b, a[2].b, a[3].b, a[4].b, a[5].s))
