#ifndef IRSSI_GJS_SIGNALS_H_
#define IRSSI_GJS_SIGNALS_H_

#include "console.h"
#include "xs-macros.h"

extern JSObject *signal_arg_map;

void gjs_irssi_sig_proxy (const void *p1, const void *p2,
                          const void *p3, const void *p4,
                          const void *p5, const void *p6);

JSBool
script_signal_remove_all(JSContext *cx, const char *data);
SCRIPT_FUN(irssi_signal_add);
SCRIPT_FUN(irssi_signal_remove);

JSBool
init_signals(JSContext *cx, JSObject *global);

#endif
