#include "functions-irc.h"
#include "functions-xs-macros.h"
#include "utils.h"
#include "classes-irc.h"

SCRIPT_FUN(irssi_irc_server_redirect_event) { /* Irssi::Irc::Server $server, string $command, int $count, string $arg, int $remote, string $failure_signal, SVptr $signals XXX */ }
SCRIPT_FUN(irssi_irc_server_redirect_peek_signal) { /* Irssi::Irc::Server $server, string $prefix, string $event, string $args XXX */ }
SCRIPT_FUN(irssi_irc_server_redirect_register) { /* string $command, int $remote, int $timeout, SVptr $start, SVptr $stop, SVptr $opt XXX */ }

SCRIPT_FUN(irssi_irc_dcc_chat_send) { /* Irssi::Irc::Dcc::Chat $dcc, string $data XXX */ }
SCRIPT_FUN(irssi_irc_dcc_ctcp_message) { /* Irssi::Irc::Server $server, string $target, Irssi::Irc::Dcc::Chat $chat, int $notice, string $msg XXX */ }
SCRIPT_FUN(irssi_irc_modes_join) { /* Irssi::Irc::Server $server, string $old, string $mode, int $channel XXX */ }

#if 0
SCRIPT_FUN[Irssi::Irc::Dcc :: close] { /* Irssi::Irc::Dcc $dcc */ }
SCRIPT_FUN[Irssi::Irc::Dcc :: destroy] { /* Irssi::Irc::Dcc $dcc */ }
SCRIPT_FUN[Irssi::Irc::Dcc :: init_rec] { /* Irssi::Irc::Dcc $dcc, Irssi::Irc::Server $server, Irssi::Irc::Dcc::Chat $chat, string $nick, string $arg */ }
SCRIPT_FUN[Irssi::Irc::Dcc :: reject] { /* Irssi::Irc::Dcc $dcc, Irssi::Irc::Server $server */ }
#endif
